const fs = require("fs");
const path = require("path");
const Jimp = require('jimp');
const sizeOf = require('image-size');

const pwd = ".";
const target_str = '.assets';

async function cropAndSave(x, y, width, height, i, element, pic) {
    const image = await Jimp.read(pic);
    await image.crop(x, y, width, height);
    const outputPath = path.join(element.split(".")[0], `${i}.png`);
    await image.writeAsync(outputPath);
    console.log(`图片 ${pic} 已切割并保存至 ${outputPath}`);
}

function createDirectoryIfNotExists(directory) {
    if (!fs.existsSync(directory)) {
        fs.mkdirSync(directory);
        console.log(`${directory}文件夹创建完成`);
    }
}

async function processFilesInDirectory(dirPath) {
    try {
        const filesInDir = await fs.promises.readdir(dirPath);
        for (let i = 0; i < filesInDir.length; i++) {
            const element = filesInDir[i];
            const imagePath = path.join(dirPath, element);
            const dimensions = sizeOf(imagePath);
            const img_y = dimensions.width > 1200 ? dimensions.width / 35 : 1200 / 35;

            for (let j = 0; dimensions.height - img_y * j > 0; j++) {
                const cropHeight = Math.min(img_y, dimensions.height - img_y * j);
                await cropAndSave(0, img_y * j, dimensions.width, cropHeight, j, element, imagePath);
            }
        }
    } catch (err) {
        console.error(err);
    }
}

function processDirectories() {
    fs.readdir(pwd, function (err, files) {
        if (err) {
            return console.log(err);
        } else {
            files.forEach(function (item) {
                if (item.includes(target_str)) {
                    const dirName = item;
                    const dirPath = path.join(pwd, dirName);

                    fs.readdir(dirPath, function (err, files) {
                        if (err) {
                            return console.log(err);
                        } else {
                            const file_name = dirName.split(target_str)[0] + ".md";
                            createDirectoryIfNotExists(file_name.split(".")[0]);

                            processFilesInDirectory(dirPath);
                        }
                    });
                }
            });
        }
    });
}

processDirectories();
